diff --git a/gcc/config/rs6000/linux64.h b/gcc/config/rs6000/linux64.h
index dbc9a52..1b6a368 100644
--- a/gcc/config/rs6000/linux64.h
+++ b/gcc/config/rs6000/linux64.h
@@ -57,13 +57,13 @@ extern int dot_symbols;
 #define DOT_SYMBOLS dot_symbols
 #endif
 
-#define TARGET_PROFILE_KERNEL profile_kernel
+#define TARGET_PROFILE_KERNEL GCC_OPTION (profile_kernel)
 
 #define TARGET_USES_LINUX64_OPT 1
 #ifdef HAVE_LD_LARGE_TOC
 #undef TARGET_CMODEL
-#define TARGET_CMODEL rs6000_current_cmodel
-#define SET_CMODEL(opt) rs6000_current_cmodel = opt
+#define TARGET_CMODEL GCC_OPTION (rs6000_current_cmodel)
+#define SET_CMODEL(opt) GCC_OPTION (rs6000_current_cmodel) = opt
 #else
 #define SET_CMODEL(opt) do {} while (0)
 #endif
@@ -81,7 +81,7 @@ extern int dot_symbols;
    -mrelocatable or -mrelocatable-lib is given.  */
 #undef RELOCATABLE_NEEDS_FIXUP
 #define RELOCATABLE_NEEDS_FIXUP \
-  (rs6000_isa_flags & rs6000_isa_flags_explicit & OPTION_MASK_RELOCATABLE)
+  (GCC_OPTION (rs6000_isa_flags) & GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_RELOCATABLE)
 
 #undef	RS6000_ABI_NAME
 #define	RS6000_ABI_NAME "linux"
@@ -90,9 +90,9 @@ extern int dot_symbols;
 #define INVALID_32BIT INVALID_64BIT
 
 #ifdef LINUX64_DEFAULT_ABI_ELFv2
-#define ELFv2_ABI_CHECK (rs6000_elf_abi != 1)
+#define ELFv2_ABI_CHECK (GCC_OPTION (rs6000_elf_abi) != 1)
 #else
-#define ELFv2_ABI_CHECK (rs6000_elf_abi == 2)
+#define ELFv2_ABI_CHECK (GCC_OPTION (rs6000_elf_abi) == 2)
 #endif
 
 #undef	SUBSUBTARGET_OVERRIDE_OPTIONS
@@ -100,46 +100,46 @@ extern int dot_symbols;
   do								\
     {								\
       if (!global_options_set.x_rs6000_alignment_flags)		\
-	rs6000_alignment_flags = MASK_ALIGN_NATURAL;		\
+	GCC_OPTION (rs6000_alignment_flags) = MASK_ALIGN_NATURAL;		\
       if (TARGET_64BIT)						\
 	{							\
 	  if (DEFAULT_ABI != ABI_AIX)				\
 	    {							\
-	      rs6000_current_abi = ABI_AIX;			\
+	      GCC_OPTION (rs6000_current_abi) = ABI_AIX;			\
 	      error (INVALID_64BIT, "call");			\
 	    }							\
-	  dot_symbols = !strcmp (rs6000_abi_name, "aixdesc");	\
+	  dot_symbols = !strcmp (GCC_OPTION (rs6000_abi_name), "aixdesc");	\
 	  if (ELFv2_ABI_CHECK)					\
 	    {							\
-	      rs6000_current_abi = ABI_ELFv2;			\
+	      GCC_OPTION (rs6000_current_abi) = ABI_ELFv2;			\
 	      if (dot_symbols)					\
 		error ("-mcall-aixdesc incompatible with -mabi=elfv2"); \
 	    }							\
-	  if (rs6000_isa_flags & OPTION_MASK_RELOCATABLE)	\
+	  if (GCC_OPTION (rs6000_isa_flags) & OPTION_MASK_RELOCATABLE)	\
 	    {							\
-	      rs6000_isa_flags &= ~OPTION_MASK_RELOCATABLE;	\
+	      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_RELOCATABLE;	\
 	      error (INVALID_64BIT, "relocatable");		\
 	    }							\
-	  if (rs6000_isa_flags & OPTION_MASK_EABI)		\
+	  if (GCC_OPTION (rs6000_isa_flags) & OPTION_MASK_EABI)		\
 	    {							\
-	      rs6000_isa_flags &= ~OPTION_MASK_EABI;		\
+	      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_EABI;		\
 	      error (INVALID_64BIT, "eabi");			\
 	    }							\
 	  if (TARGET_PROTOTYPE)					\
 	    {							\
-	      target_prototype = 0;				\
+	      GCC_OPTION (target_prototype) = 0;				\
 	      error (INVALID_64BIT, "prototype");		\
 	    }							\
-	  if ((rs6000_isa_flags & OPTION_MASK_POWERPC64) == 0)	\
+	  if ((GCC_OPTION (rs6000_isa_flags) & OPTION_MASK_POWERPC64) == 0)	\
 	    {							\
-	      rs6000_isa_flags |= OPTION_MASK_POWERPC64;	\
+	      GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_POWERPC64;	\
 	      error ("-m64 requires a PowerPC64 cpu");		\
 	    }							\
-	  if ((rs6000_isa_flags_explicit			\
+	  if ((GCC_OPTION (rs6000_isa_flags_explicit)			\
 	       & OPTION_MASK_MINIMAL_TOC) != 0)			\
 	    {							\
 	      if (global_options_set.x_rs6000_current_cmodel	\
-		  && rs6000_current_cmodel != CMODEL_SMALL)	\
+		  && GCC_OPTION (rs6000_current_cmodel) != CMODEL_SMALL)	\
 		error ("-mcmodel incompatible with other toc options"); \
 	      SET_CMODEL (CMODEL_SMALL);			\
 	    }							\
@@ -147,13 +147,13 @@ extern int dot_symbols;
 	    {							\
 	      if (!global_options_set.x_rs6000_current_cmodel)	\
 		SET_CMODEL (CMODEL_MEDIUM);			\
-	      if (rs6000_current_cmodel != CMODEL_SMALL)	\
+	      if (GCC_OPTION (rs6000_current_cmodel) != CMODEL_SMALL)	\
 		{						\
 		  if (!global_options_set.x_TARGET_NO_FP_IN_TOC) \
-		    TARGET_NO_FP_IN_TOC				\
-		      = rs6000_current_cmodel == CMODEL_MEDIUM;	\
+		    GCC_OPTION (TARGET_NO_FP_IN_TOC)				\
+		      = GCC_OPTION (rs6000_current_cmodel) == CMODEL_MEDIUM;	\
 		  if (!global_options_set.x_TARGET_NO_SUM_IN_TOC) \
-		    TARGET_NO_SUM_IN_TOC = 0;			\
+		    GCC_OPTION (TARGET_NO_SUM_IN_TOC) = 0;			\
 		}						\
 	    }							\
 	}							\
@@ -304,9 +304,9 @@ extern int dot_symbols;
 #define OPTION_UCLIBC (DEFAULT_LIBC == LIBC_UCLIBC)
 #define OPTION_BIONIC (DEFAULT_LIBC == LIBC_BIONIC)
 #else
-#define OPTION_GLIBC  (linux_libc == LIBC_GLIBC)
-#define OPTION_UCLIBC (linux_libc == LIBC_UCLIBC)
-#define OPTION_BIONIC (linux_libc == LIBC_BIONIC)
+#define OPTION_GLIBC  (GCC_OPTION (linux_libc) == LIBC_GLIBC)
+#define OPTION_UCLIBC (GCC_OPTION (linux_libc) == LIBC_UCLIBC)
+#define OPTION_BIONIC (GCC_OPTION (linux_libc) == LIBC_BIONIC)
 #endif
 
 /* Determine what functions are present at the runtime;
@@ -424,7 +424,7 @@ extern int dot_symbols;
 #define MINIMAL_TOC_SECTION_ASM_OP \
   (TARGET_64BIT						\
    ? "\t.section\t\".toc1\",\"aw\""			\
-   : ((TARGET_RELOCATABLE || flag_pic)			\
+   : ((TARGET_RELOCATABLE || GCC_OPTION (flag_pic))			\
       ? "\t.section\t\".got2\",\"aw\""			\
       : "\t.section\t\".got1\",\"aw\""))
 
@@ -490,7 +490,7 @@ extern int dot_symbols;
 #define	ASM_DECLARE_FUNCTION_SIZE(FILE, FNAME, DECL)			\
   do									\
     {									\
-      if (!flag_inhibit_size_directive)					\
+      if (!GCC_OPTION (flag_inhibit_size_directive))					\
 	{								\
 	  fputs ("\t.size\t", (FILE));					\
 	  if (TARGET_64BIT && DOT_SYMBOLS)				\
@@ -525,9 +525,9 @@ extern int dot_symbols;
 	   && ((TARGET_64BIT						\
 		&& (TARGET_MINIMAL_TOC					\
 		    || (SCALAR_FLOAT_MODE_P (GET_MODE (X))		\
-			&& ! TARGET_NO_FP_IN_TOC)))			\
+			&& ! GCC_OPTION (TARGET_NO_FP_IN_TOC))))			\
 	       || (!TARGET_64BIT					\
-		   && !TARGET_NO_FP_IN_TOC				\
+		   && !GCC_OPTION (TARGET_NO_FP_IN_TOC)				\
 		   && !TARGET_RELOCATABLE				\
 		   && SCALAR_FLOAT_MODE_P (GET_MODE (X))		\
 		   && BITS_PER_WORD == HOST_BITS_PER_INT)))))
@@ -537,7 +537,7 @@ extern int dot_symbols;
    true if the symbol may be affected by dynamic relocations.  */
 #undef	ASM_PREFERRED_EH_DATA_FORMAT
 #define	ASM_PREFERRED_EH_DATA_FORMAT(CODE, GLOBAL) \
-  ((TARGET_64BIT || flag_pic || TARGET_RELOCATABLE)			\
+  ((TARGET_64BIT || GCC_OPTION (flag_pic) || TARGET_RELOCATABLE)			\
    ? (((GLOBAL) ? DW_EH_PE_indirect : 0) | DW_EH_PE_pcrel		\
       | (TARGET_64BIT ? DW_EH_PE_udata8 : DW_EH_PE_sdata4))		\
    : DW_EH_PE_absptr)
diff --git a/gcc/config/rs6000/linuxaltivec.h b/gcc/config/rs6000/linuxaltivec.h
index ebd03c9..eef7264 100644
--- a/gcc/config/rs6000/linuxaltivec.h
+++ b/gcc/config/rs6000/linuxaltivec.h
@@ -29,4 +29,4 @@
 #endif
 
 #undef  SUBSUBTARGET_OVERRIDE_OPTIONS
-#define SUBSUBTARGET_OVERRIDE_OPTIONS rs6000_altivec_abi = 1
+#define SUBSUBTARGET_OVERRIDE_OPTIONS GCC_OPTION (rs6000_altivec_abi) = 1
diff --git a/gcc/config/rs6000/rs6000-c.c b/gcc/config/rs6000/rs6000-c.c
index 0f1dafc..0d2a722 100644
--- a/gcc/config/rs6000/rs6000-c.c
+++ b/gcc/config/rs6000/rs6000-c.c
@@ -74,7 +74,7 @@ rs6000_pragma_longcall (cpp_reader *pfile ATTRIBUTE_UNUSED)
   if (pragma_lex (&x) != CPP_EOF)
     warning (OPT_Wpragmas, "junk at end of #pragma longcall");
 
-  rs6000_default_long_calls = (n == integer_one_node);
+  GCC_OPTION (rs6000_default_long_calls) = (n == integer_one_node);
 }
 
 /* Handle defining many CPP flags based on TARGET_xxx.  As a general
@@ -376,7 +376,7 @@ void
 rs6000_cpu_cpp_builtins (cpp_reader *pfile)
 {
   /* Define all of the common macros.  */
-  rs6000_target_modify_macros (true, rs6000_isa_flags,
+  rs6000_target_modify_macros (true, GCC_OPTION (rs6000_isa_flags),
 			       rs6000_builtin_mask_calculate ());
 
   if (TARGET_FRE)
@@ -411,7 +411,7 @@ rs6000_cpu_cpp_builtins (cpp_reader *pfile)
       ||(TARGET_HARD_FLOAT && TARGET_FPRS && !TARGET_DOUBLE_FLOAT))
     builtin_define ("_SOFT_DOUBLE");
   /* Used by lwarx/stwcx. errata work-around.  */
-  if (rs6000_cpu == PROCESSOR_PPC405)
+  if (GCC_OPTION (rs6000_cpu) == PROCESSOR_PPC405)
     builtin_define ("__PPC405__");
   /* Used by libstdc++.  */
   if (TARGET_NO_LWSYNC)
@@ -476,7 +476,7 @@ rs6000_cpu_cpp_builtins (cpp_reader *pfile)
       break;
     }
 
-  switch (rs6000_current_abi)
+  switch (GCC_OPTION (rs6000_current_abi))
     {
     case ABI_V4:
       builtin_define ("_CALL_SYSV");
@@ -502,25 +502,25 @@ rs6000_cpu_cpp_builtins (cpp_reader *pfile)
 
   /* Whether aggregates passed by value are aligned to a 16 byte boundary
      if their alignment is 16 bytes or larger.  */
-  if ((TARGET_MACHO && rs6000_darwin64_abi)
+  if ((TARGET_MACHO && GCC_OPTION (rs6000_darwin64_abi))
       || DEFAULT_ABI == ABI_ELFv2
-      || (DEFAULT_ABI == ABI_AIX && !rs6000_compat_align_parm))
+      || (DEFAULT_ABI == ABI_AIX && !GCC_OPTION (rs6000_compat_align_parm)))
     builtin_define ("__STRUCT_PARM_ALIGN__=16");
 
   /* Generate defines for Xilinx FPU. */
-  if (rs6000_xilinx_fpu) 
+  if (GCC_OPTION (rs6000_xilinx_fpu)) 
     {
       builtin_define ("_XFPU");
-      if (rs6000_single_float && ! rs6000_double_float)
+      if (GCC_OPTION (rs6000_single_float) && ! GCC_OPTION (rs6000_double_float))
 	{
-	  if (rs6000_simple_fpu) 
+	  if (GCC_OPTION (rs6000_simple_fpu)) 
 	    builtin_define ("_XFPU_SP_LITE"); 
 	  else 
 	    builtin_define ("_XFPU_SP_FULL");
 	}
-      if (rs6000_double_float)
+      if (GCC_OPTION (rs6000_double_float))
 	{
-	  if (rs6000_simple_fpu) 
+	  if (GCC_OPTION (rs6000_simple_fpu)) 
 	    builtin_define ("_XFPU_DP_LITE");
 	  else
 	    builtin_define ("_XFPU_DP_FULL");
@@ -4286,7 +4286,7 @@ altivec_resolve_overloaded_builtin (location_t loc, tree fndecl,
       /* If we are targeting little-endian, but -maltivec=be has been
 	 specified to override the element order, adjust the element
 	 number accordingly.  */
-      if (!BYTES_BIG_ENDIAN && rs6000_altivec_element_order == 2)
+      if (!BYTES_BIG_ENDIAN && GCC_OPTION (rs6000_altivec_element_order) == 2)
 	{
 	  unsigned int last_elem = TYPE_VECTOR_SUBPARTS (arg1_type) - 1;
 	  arg2 = fold_build2_loc (loc, MINUS_EXPR, TREE_TYPE (arg2),
@@ -4391,7 +4391,7 @@ altivec_resolve_overloaded_builtin (location_t loc, tree fndecl,
       /* If we are targeting little-endian, but -maltivec=be has been
 	 specified to override the element order, adjust the element
 	 number accordingly.  */
-      if (!BYTES_BIG_ENDIAN && rs6000_altivec_element_order == 2)
+      if (!BYTES_BIG_ENDIAN && GCC_OPTION (rs6000_altivec_element_order) == 2)
 	{
 	  unsigned int last_elem = TYPE_VECTOR_SUBPARTS (arg1_type) - 1;
 	  arg2 = fold_build2_loc (loc, MINUS_EXPR, TREE_TYPE (arg2),
